/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/

/* 
 * @author HyperCast Team
 */


// TODO No comments in this file

package gui;

public class GeoAddress
{
	public float longitude;
	public float latitude;
	public float adjustX, adjustY;
	
	public GeoAddress(float lo, float lat){
		longitude=lo;
		latitude=lat;
		adjustX=0;
		adjustY=0;
	}
	public GeoAddress(float lo, float lat, float adjX, float adjY){
		longitude=lo;
		latitude=lat;
		adjust(adjX, adjY);
	}
	public GeoAddress(String ll){
		int sep=ll.indexOf(",");
        longitude = Float.parseFloat(ll.substring(0, sep));
        latitude = Float.parseFloat(ll.substring(sep+1));
        adjust(0,0);
	}
	public GeoAddress(String ll, float adjX, float adjY){
		int sep=ll.indexOf(",");
        longitude = Float.parseFloat(ll.substring(0, sep));
        latitude = Float.parseFloat(ll.substring(sep+1));
        adjustX=adjX;
		adjustY=adjY;
	}
	public void shift(float dx, float dy){
		adjustX+=dx;
		adjustY+=dy;	
	}
	public void adjust(float adjX, float adjY){
		adjustX=adjX;
		adjustY=adjY;
	}
		
	public float distanceTo(GeoAddress g0){
		GeoAddress g1=getAddressAfterShift();
		GeoAddress g2=g0.getAddressAfterShift();
		return (float)Math.sqrt(Math.pow(g1.longitude-g2.longitude, 2)+Math.pow(g1.latitude-g2.latitude,2));
	}
	public String toString(){
		String los, las;
		if(longitude>=0)los=""+longitude+"E";
		else los=""+(-longitude)+"W";	
		if(latitude>=0)las=""+latitude+"N";
		else las=""+(-latitude)+"S";
		
		return los+","+las;
	}
	public GeoAddress getAddressAfterShift(){
		return new GeoAddress(longitude+adjustX, latitude+adjustY);	
	}
	
}
