/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/

/* 
 * @author HyperCast Team
 */

// TODO Add/improve comments 

package gui;

import hypercast.I_LogicalAddress;
import hypercast.DT.DT_LogicalAddress;
import hypercast.MonitorAndControl.*;

import java.util.*;
import org.w3c.dom.*;

import runcontrol.RunControl;

public class RunDTNetwork extends RunNetwork{
    
    public RunDTNetwork(RunControl rc2inst) { super(rc2inst); }
    
    
    
    
    
    //for drawing multicast tree
    public OverlayNode getLogicalNextHop(OverlayNode src, OverlayNode dst ) {

        Enumeration neighbor = src.getLogicalNeighbor();

        double min = 3.15;
        OverlayNode nextHop = null;

        /*lotusDebut.println( "Logical route from:" +
                    src.getAddress().toString() +
                    "==>" +
                    dst.getAddress().toString() );
        */
        while( neighbor.hasMoreElements() ){
            OverlayNode n = (OverlayNode)neighbor.nextElement();
            //lotusDebut.println("Neighbor:" + n.getAddress().toString() );

            double sx = ((DT_LogicalAddress)((RunDTNode)src.getProtocol()).getLogicalAddress()).getX();
            double sy = ((DT_LogicalAddress)((RunDTNode)src.getProtocol()).getLogicalAddress()).getY();
            double dx = ((DT_LogicalAddress)((RunDTNode)dst.getProtocol()).getLogicalAddress()).getX();
            double dy = ((DT_LogicalAddress)((RunDTNode)dst.getProtocol()).getLogicalAddress()).getY();
            double nx = ((DT_LogicalAddress)((RunDTNode)n.getProtocol()).getLogicalAddress()).getX();
            double ny = ((DT_LogicalAddress)((RunDTNode)n.getProtocol()).getLogicalAddress()).getY();


            double sn = (sx-nx)*(sx-nx) + (sy-ny)*(sy-ny);
            double sd = (sx-dx)*(sx-dx) + (sy-dy)*(sy-dy);
            double nd = (nx-dx)*(nx-dx) + (ny-dy)*(ny-dy);

            double test = (sd + sn - nd ) /( 2*Math.sqrt(sd*sn));

            double angle = Math.acos(test);
            //lotusDebut.println("angle with "+ n.getAddress().toString() + "is" + angle );
            if( angle < min ) {
                min = angle;
                nextHop = n;
            }
        }
        return nextHop;
        
    }
    
    
	public I_LogicalAddress parseLogicalAddress(String la){
		return new DT_LogicalAddress(la);	
	}
    
    
    
    public RunNode createRunNodeInst(physicalInterface p, int pIndex, int sIndex){
        return new RunDTNode(p, null, pIndex, sIndex);
    }
    

}
