/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/

/* 
 * @author HyperCast Team
 * @author gd4j
 * Created on May 7, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */


package gui;

import java.util.Random;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import hypercast.I_LogicalAddress;
import hypercast.HC.*;
import hypercast.util.XmlUtil;

public class RunHCNode extends RunNode {
	HC_LogicalAddress logicalAddress;
	XYAddress coords;
	RunHCNetwork network;
	/**
	 * @param p
	 * @param pIndex
	 * @param sIndex
	 */
	public RunHCNode(
		physicalInterface p,
		HC_LogicalAddress la,
		int pIndex,
		int sIndex,
		RunHCNetwork net) {
		super(p, pIndex, sIndex);
		logicalAddress = la;
		network = net;
		//coords = new XYAddress(200, 200);
	}

	/* (non-Javadoc)
	 * @see RunNode#getLogicalAddress()
	 */
	public I_LogicalAddress getLogicalAddress() {
		return logicalAddress;
	}

	/* (non-Javadoc)
	 * @see RunNode#setLogicalAddress(hypercast.I_LogicalAddress)
	 */
	public void setLogicalAddress(I_LogicalAddress la) {
		logicalAddress = (HC_LogicalAddress) la;
	}

	/* (non-Javadoc)
	 * @see RunNode#setLogicalAddress(java.lang.String)
	 */
	public void setLogicalAddress(String la) {
		if (!la.equals("Unknown"))
			logicalAddress = new HC_LogicalAddress(la);
		else
			logicalAddress = null;
	}

	/* (non-Javadoc)
	 * @see RunNode#getCoords()
	 */
	public XYAddress getXYAddress() {
		int n, m;
		n = network.getMaxID() + 1;

		if (logicalAddress != null && !logicalAddress.toString().equals("Unknown"))
			m = Integer.parseInt(logicalAddress.toString());
		else {
			return new XYAddress(200, 200);
		}
		//lotusDebug.println("max="+max);
		//lotusDebug.println("m="+m+" n="+n);

		double angle = 2.0 * Math.PI * m / n - Math.PI / 2;

		double x, y;

		x = 150 * Math.cos(angle);
		y = 150 * Math.sin(angle);

		m = logicalAddress.getGrayIndex();
		int bitn = (int) (Math.log(n) / Math.log(2));
		String bits = "";
		for (int i = 0; i < bitn; i++) {
			int r = m - (m / 2) * 2;
			m = m / 2;
			if (r > 0)
				bits = "1" + bits;
			else
				bits = "0" + bits;
		}

		if (phy != null)
			 ((OverlayNode) phy).setName("" + logicalAddress + " (" + bits + ")");

		return new XYAddress((int) (200 + x), (int) (200 + y));

	}

}
