/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/

/* 
 * @author HyperCast Team
 * @author gd4j
 * Created on May 6, 2004
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

package gui;

import java.util.Properties;
import java.util.Random;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import hypercast.HyperCastConfig;
import hypercast.HyperCastStatsException;
import hypercast.I_LogicalAddress;
import hypercast.MonitorAndControl.MonMessage;
import hypercast.SPT.*;
import hypercast.util.XmlUtil;
import hypercast.util.XmlUtil;

import runcontrol.RunControl;

public class RunSPTNode extends RunTreeNode {
	SPT_LogicalAddress logicalAddress;
	SPT_LogicalAddress parentAddress;
	XYAddress coords;
	
	/**
	 * @param p
	 * @param pIndex
	 * @param sIndex
	 */
	public RunSPTNode(physicalInterface p, SPT_LogicalAddress la, int pIndex, int sIndex, RunSPTNetwork net) {
		super(p, pIndex, sIndex, net);
		logicalAddress = la;
		
		
	}

	/* (non-Javadoc)
	 * @see RunNode#getLogicalAddress()
	 */
	public I_LogicalAddress getLogicalAddress() {
		return logicalAddress;
	}

	/* (non-Javadoc)
	 * @see RunNode#setLogicalAddress(hypercast.I_LogicalAddress)
	 */
	public void setLogicalAddress(I_LogicalAddress la) {
		logicalAddress = (SPT_LogicalAddress) la;
	}

	/* (non-Javadoc)
	 * @see RunNode#setLogicalAddress(java.lang.String)
	 */
	public void setLogicalAddress(String la) {
		logicalAddress = new SPT_LogicalAddress(la);
	}
	public String [] createQuery(){
		String []common=super.createQuery();
		String []query=new String[common.length+1];
		for(int i=0;i<common.length;i++)
			query[i]=common[i];
		
		query[common.length]="/Node/Parent";
		
		return query;
	}
	public boolean readQueryResult(MonMessage reply, String prefix) throws NumberFormatException, HyperCastStatsException{
		if(super.readQueryResult(reply, prefix)){
			int parentId = Integer.parseInt(XmlUtil.getScalarValue(reply.getStatValue(XmlUtil.createXPath(prefix+"/Node/Parent"))));
			if(parentId>0)
				this.setParent(new SPT_LogicalAddress(parentId));
			else this.setParent(null);
			return true;
		}
		else return false;
		
	}
	
	
	

}
