/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/

/* 
 * @author HyperCast Team
 */

// TODO No comments in this file


package gui;

import java.lang.*;


/**
	The View class decide the way GUI_DisplayWindow displays
	
**/

public class View{
	/** the display scale */
    public float scale; 

    /** view point, used to move the part of display shown */
    public int viewX, viewY;
    
    public int mode; //logical view or geographic view
    
    public boolean autofit;
    
    public final static int VIEW_LOGICAL =0;
    public final static int VIEW_GEOGRAPHIC =1;
    
    public String overlayID;
    
    public View(float sc, int vX, int vY, int md, boolean af, String olid){
    	scale=sc;
    	viewX=vX;
    	viewY=vY;
    	mode=md;
    	autofit=af;
    	overlayID= olid;
    }
    
    public boolean equals(View v){
    	
    	boolean equal1;
    	if(autofit && v.autofit)equal1=(mode==v.mode);
    	else equal1=(scale==v.scale && viewX==v.viewX && viewY==v.viewY &&
    			mode==v.mode && autofit==v.autofit);
    	
    	if(overlayID==null)
	    	return  equal1 && v.overlayID==null;
    	else
    		return  equal1 && overlayID.equals(v.overlayID);
    }
}
