/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/

/* 
 * @author HyperCast Team
 */

// TODO Improve commenting 

package runcontrol.commands;

import java.io.BufferedReader;
import java.io.PrintWriter;

import runcontrol.RunControl;
import runcontrol.RunControlCommand;
import runcontrol.CommandFailureException;


public final class FlushSocketsCommand
    extends RunControlCommand
{

	RunControl runControl;
	
	public String name() {
		return "resync_sockets";
	}
	
	public String parameterDescription()
    {
        return "";
    }
	
	public FlushSocketsCommand(RunControl rc){
		runControl = rc;
	}
	/* (non-Javadoc)
	 * @see runcontrol.RunControlCommand#action(java.lang.String, java.lang.String[], java.io.BufferedReader, java.io.PrintWriter, java.io.PrintWriter)
	 */
	public void action(String command, String[] args, BufferedReader in, PrintWriter out, PrintWriter err) 
            throws Exception
    {
		out.println("Flushing all sockets");
		runControl.getSocketStatusTable().flushAllSockets();
	}
	public int minParameters() { return 0; }
    
    public int maxParameters() { return 0; }
    
	/* (non-Javadoc)
	 * @see runcontrol.RunControlCommand#description()
	 */
	public String description() {
		return "Requests that all currently running overlay sockets are stopped";
	}

	/* (non-Javadoc)
	 * @see runcontrol.RunControlCommand#longDescription()
	 */
	public String longDescription() {
		return "Requests that all currently running overlay sockets are stopped. The command has,\n" +
				" in most cases, the same effect as the command stop_sockets all, but there are \n" +
				"differences. The flush_sockets command contacts all RunServers in the portal list \n" +
				"and requests that all overlay sockets leave the overlay network. Differently, \n" +
				"stop_sockets all only contacts RunServers that, according to the current state \n" +
				"information of RunControl, have started overlay sockets. Thus, when the state \n" +
				"information at RunControl is not consistent with the actual state of the remote \n" +
				"overlay sockets, the flush_sockets command can help to recover to a consistent state. ";
	}

}
