/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/

/* 
 * @author HyperCast Team
 */


// TODO Add comments 

package runcontrol.commands;

import runcontrol.RunControl;
import runcontrol.RunControlCommand;
import runcontrol.CommandFailureException;

import java.io.BufferedReader;
import java.io.PrintWriter;

import java.util.StringTokenizer;

/* Generic command to pause.*/
public final class PauseCommand
    extends RunControlCommand
{
    public PauseCommand (final RunControl runControl)
    {
    }

    public String name()
    {
        return "pause";
    }

	public String parameterDescription() {
		return " [text] [text] [text] [...] ";
	}

	public String description() {
		return " echos text and waits for return";
	}

	public String longDescription() {
		return " prints out text and waits for the user to hit return.";
	}

	public int minParameters() {
		return 0;
	}
	public int maxParameters() {
		return Integer.MAX_VALUE;
	}

	public void action(
		String command,
		String firstArg,
		String secondArg,
		String thirdArg,
		StringTokenizer furtherArgs,
		BufferedReader in,
		PrintWriter out,
		PrintWriter err)
		throws Exception {
		if (firstArg != null) {
			out.print(firstArg + " ");
			if (secondArg != null)
				out.print(secondArg + " ");
			if (thirdArg != null)
				out.print(thirdArg + " ");

			while (furtherArgs.hasMoreElements()) {
				out.print(furtherArgs.nextToken() + " ");
			}

			out.println();
		} else {
			out.println("Hit Enter to continue.");
		}

		in.readLine();
	}
}
